 /*
  * Khoros: $Id: jp.h,v 1.2 1991/12/18 09:13:25 dkhoros Exp $
  */

 /*
  * $Log: jp.h,v $
 * Revision 1.2  1991/12/18  09:13:25  dkhoros
 * HellPatch3
 *
  */ 

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1990, University of New Mexico.  All rights reserved.
 * 
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as too the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *----------------------------------------------------------------------
 */

#include "unmcopyright.h"	 /* Copyright 1990 by UNM */

#ifndef _jp_h_
#define _jp_h_

#include "JPEvent.h"	 /* Copyright 1990 by UNM */


/* >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
   >>>>                                                          <<<<
   >>>>	     file: jp.h  					 <<<<
   >>>>                                                          <<<<
   >>>>      contains: function declarations, #defines,          <<<<
   >>>>                structures, and global variables used     <<<<
   >>>>		       by journal record & journal playback      <<<<
   >>>>                                                          <<<<
   >>>>      written by: Mark Young & Danielle Argiro            <<<<
   >>>>                                                          <<<<
   >>>>>>>>>>>>>>>>>>>>>>>>>>>>> <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< */



/*
 *  function declarations
 */
char   *xvf_find_name();
Widget xvf_find_widget();
Widget xvf_find_xvform_widget();
Window xvf_find_window();

/*
 *  #defines
 */
#define XVF_WINDOW 1
#define XVF_WIDGET 2

/*
 *  global variables for journal playback
 */
float    jp_speed;
int      jp_speed_flag, jp_halt, jp_grab;
Window   jp_window;
Widget   jp_control, xvf_create_jp_control();
FILE	*play_file, *record_file;
char	*play_filename, *record_filename;


/*
 *  callbacks for journal playback.  The time callback is for when reading
 *  events from a file.  The input callback is for when the play_file is set
 *  to stdin which we will listen to for playing back events.
 */
void jp_file_cb(), jp_input_cb();


/*
 * structure holding values pertaining to 
 * journal playback control widget
 */
typedef struct _JP_Data {
	Widget status;
	Widget val;
	} JP_Data;


JP_Data *jp_data;


#endif
/* Don't add after this line */
